

import ch.aplu.jgamegrid.*;
import ch.aplu.util.*;

public class Memory extends GameGrid implements GGMouseListener
{
  private boolean isReady = true;
  private MemoryCard card1;
  private MemoryCard card2;

  public Memory()
  {
	//  Gamegrid 2-dimensionales Spielfeld aus Zellen
	//  Memory-Konstruktor:
	//  Erstelle ein Spielfeld 4x4 Zellen
    super(4, 4, 115, null, null, false);
    
    // Keine Zustzlichen Meldungen in der Console
  
    
    // Datenstruktur 16 Karten (4x4 = 16)
    MemoryCard[] cards = new MemoryCard[16];

    // Erstelle 16 "Actors" mit Kartenmotiven (sprites)
    // Hierfr verwenden wir die eigene abgeleitete Klasse MemoryCard
    // -> vorher anschauen
    for (int i = 0; i < 16; i++)
    {
      if (i < 8)
        cards[i] = new MemoryCard(i);
      else
        cards[i] = new MemoryCard(i - 8);
      
      // stellt die Karte in eine Zufllige freie Stelle im 4x4 Gitter
      Location location = this.getRandomEmptyLocation();
      this.addActor(cards[i], location);
      System.out.print ("Karten-ID:"+cards[i].getId());  
      System.out.println (" an Zelle:"+location.x +"/"+ location.y+ " erstellt");
      // unsichtbar
      cards[i].setVisible(false);
    }
    
    // MouseListener fr Klicken auf die Karten hinzufgen
    this.addMouseListener(this, GGMouse.lPress);
    this.doRun();
    this.show();
    // Application thread used to flip back cards
    while (true)
    {
      Monitor.putSleep();  // Wait until there is something to do
      delay(1000);
      card1.setVisible(false);  // Flip cards back
      card2.setVisible(false);
      isReady = true;
      setMouseEnabled(true);  // Rearm mouse events
    }
  } 

  public boolean mouseEvent(GGMouse mouse)
  {
	// Schaue auf welche Zelle geklickt wurde.
    Location location = this.toLocation(mouse.getX(), mouse.getY());
    
    System.out.println ("Mouse:"+mouse.getX() +"/"+ mouse.getY());
    System.out.println ("Zelle:"+location.x +"/"+ location.y);
    
    MemoryCard card = (MemoryCard)this.getOneActorAt(location);
    
    System.out.println ("Karten-ID:"+card.getId());
    
    if (card.getIdVisible() == 0)  // Card already flipped->no action
      return true;

    card.setVisible(true); // Show picture
    if (isReady)
    {
      isReady = false;
      card1 = card;
    }
    else
    {
      card2 = card;
      if (card1.getId() == card2.getId())  // Pair found, let them visible
        isReady = true;
      else
      {
        setMouseEnabled(false); // Disable mouse events until application thread flipped back cards
        Monitor.wakeUp();
      }
    }
    return true;
  }

  public static void main(String[] args)
  {
    new Memory();
  }
}


